<script lang="ts">
    import { createEventDispatcher } from 'svelte';
    import SettingPanel from "./panel.svelte";
    import type { ISettingItem } from '$lib/types';

    const dispatch = createEventDispatcher();

    export let panels: {
        dataname: string;
        title: string;
        items: ISettingItem[];
    }[];
    let names = panels.map((panel) => {
        return { name: panel.dataname, title: panel.title}
    });

    let focusName = names[0].name;

    function changed(e: CustomEvent, dataname: string) {
        dispatch('changed', { dataname: dataname, detail: e.detail });
    }

</script>

<div class="fn__flex-1 fn__flex config__panel">
    <ul class="b3-tab-bar b3-list b3-list--background">
        {#each names as name}
            <li data-name="editor"
                class:b3-list-item--focus={name.name === focusName}
                class="b3-list-item"
                on:click={() => {focusName = name.name}} on:keydown={() => {}}
            >
                <span class="b3-list-item__text">{name.title}</span>
            </li>
        {/each}
    </ul>
    <div class="config__tab-wrap">
        {#each panels as panel}
            <SettingPanel
                dataname={panel.dataname}
                settingItems={panel.items}
                display={panel.dataname === focusName}
                on:changed={(e) => changed(e, panel.dataname)}
            />
        {/each}
    </div>
</div>

<style>
    .config__panel {
        height: 100%;
    }
    .config__panel>ul>li {
        padding-left: 1rem;
    }
</style>